#include <opencv2\opencv.hpp>
#include <opencv2/core/core.hpp>
#include <opencv2/imgproc/imgproc.hpp>
#include <opencv2/highgui/highgui.hpp>
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <iostream>
#include <fstream>

//gpFl̂l
#define F_th 0.5

//]ΏۃV[
#define SINGLE
//#define DOUBLE
//#define MULTI


//x摜̃pX
char label_pass[1024] =  "F:/APC/apc_test_tex/mask_label";

//]Ώۉ摜̃pX
char test_pass[1024] =   "F:/APC/apc_test_tex/0511";

//]ʏo͗p̃pX
char result_pass[1024] = "F:/APC/apc_test_tex/mask_label";

//doubleV[̃ACep^[
int double_name[75][2] = {{1, 6}, {1, 12}, {1, 18}, {2, 5}, {2, 11}, {2, 19}, {3, 3}, {3, 8}, {3, 15}, {4, 7}, {4, 22}, {4, 25}, 
						  {5, 13}, {5, 16}, {5, 24}, {6, 10}, {6, 14}, {6, 21}, {7, 17}, {7, 20}, {7, 23}, {8, 1}, {8, 9}, {8, 18},
						  {9, 2}, {9, 12}, {9, 20}, {10, 7}, {10, 16}, {10, 22}, {11, 4}, {11, 11}, {11, 18}, {12, 8}, {12, 19}, {12, 24}, 
						  {13, 3}, {13, 10}, {13, 15}, {14, 5}, {14, 13}, {14, 17}, {15, 9}, {15, 14}, {15, 21}, {16, 7}, {16, 23}, {16, 25}, 
						  {17, 1}, {17, 2}, {17, 4}, {18, 9}, {18, 12}, {18, 17}, {19, 13}, {19, 20}, {19, 24}, {20, 16}, {20, 21}, {20, 23}, 
						  {21, 5}, {21, 11}, {21, 14}, {22, 6}, {22, 8}, {22, 15}, {23, 1}, {23, 19}, {23, 25}, {24, 2}, {24, 3}, {24, 10}, 
					      {25, 6}, {25, 14}, {25, 22}};

//multiV[(3ACe)̃ACep^[
int multi3_name[34][3] = {{1, 4, 11}, {1, 10, 25}, {2, 8, 19}, {3, 12, 14}, {4, 8, 21}, {4, 13, 22}, {5, 6, 9}, {5, 11, 12}, 
						  {6, 6, 8}, {6, 14, 19}, {7, 1, 10}, {7, 17, 21}, {8, 22, 24}, {10, 13, 15}, {11, 9, 14}, {12, 20, 23}, 
						  {13, 21, 25}, {14, 4, 14}, {14, 10, 3}, {14, 19, 22}, {15, 16, 24}, {16, 11, 17}, {17, 12, 22}, 
						  {19, 8, 19}, {20, 2, 6}, {20, 13, 24}, {20, 17, 20}, {20, 23, 24}, {21, 7, 14}, {22, 9, 13}, {23, 6, 17}, 
						  {24, 10, 13}, {25, 1, 3}, {25, 19, 24}};

//multiV[(4ACe)̃ACep^[
int multi4_name[6][4] =  {{2, 7, 13, 24}, {3, 5, 16, 18}, {3, 6, 15, 18}, {9, 3, 25, 12}, {11, 2, 18, 6}, {18, 3, 4, 23}};

//x摜̊eACeJ[
int item_color[26][3] = {{0, 0, 0}, {128, 0, 0}, {255, 0, 0}, {0, 128, 0}, {128, 128, 0}, {255, 128, 0}, 
						 {0, 255, 0}, {128, 255, 0}, {255, 255, 0}, {0, 0, 128}, {128, 0, 128}, 
						 {255, 0, 128}, {0, 128, 128}, {128, 128, 128}, {255, 128, 128}, {0, 255, 128}, 
						 {128, 255, 128}, {255, 255, 128}, {0, 0, 255}, {128, 0, 255}, {255, 0, 255}, 
						 {0, 128, 255}, {128, 128, 255}, {255, 128, 255}, {0, 255, 255}, {128, 255, 255}};

//딻z
int result_bool[3] = {0, 0, 0};
//[0] Wʔp
//[1] ZOe[Vʔp
//[2] JEgp

//W̐딻֐(x摜, ]Ώۉ摜, FACeԍ)
int point_evaluation(cv::Mat label_img, cv::Mat test_img, int item_num);

//ZOe[VFlZo֐(x摜, ]Ώۉ摜, FACeԍRGBl)
double seg_evaluation(cv::Mat label_img, cv::Mat seg_img, int item_R, int item_G, int item_B);

//e]sp̊֐(xpX, ]ΏۃpX, FACeԍ, FACeԍRGBl)
void evaluation(char Label_dir[1024], char Test_dir[1024], int item_num, int item_R, int item_G, int item_B);

int main(){
	int item_evaluation[26][3];

	FILE *result;
	errno_t error;

	char label_dir[1024];
	char test_dir[1024];

	for(int x = 0 ; x < 26 ; x++){
		for(int y = 0 ; y < 3 ; y++){
			item_evaluation[x][y] = 0;
		}
	}

//Single]
#ifdef SINGLE
	for(int x = 0 ; x < 26 ; x++){
		for(int y = 0 ; y < 3 ; y++){
			item_evaluation[x][y] = 0;
		}
	}
	for(int pattern = 1 ; pattern <= 25 ; pattern++){
		for(int scene = 1 ; scene <= 30 ; scene++){

			sprintf_s(label_dir, "%s/single/%d/%d", label_pass, pattern, scene);
			sprintf_s(test_dir,  "%s/single/%d/%d/%d", test_pass, pattern, scene, pattern);

			evaluation(label_dir, test_dir, pattern, item_color[pattern][0], item_color[pattern][1], item_color[pattern][2]);

			item_evaluation[pattern][0]++;
			for(int num = 0 ; num < 3 ; num++){
				item_evaluation[pattern][num+1] = item_evaluation[pattern][num+1] + result_bool[num];
			}
		}//scene
		printf("single item_num : %d\n", pattern);
	}//pattern

	printf("\n");

	sprintf_s(result_pass, "%s/single_F%.3f_result.txt", result_pass, F_th);
	error = fopen_s(&result, result_pass, "w");
	fprintf(result, "          point     segmentation\n");

	for(int x = 1 ; x < 26 ; x++){
		fprintf(result, "item_%02d : %02d/%02d        %02d/%02d\n", 
			x, 
			item_evaluation[x][1], item_evaluation[x][0], 
			item_evaluation[x][2], item_evaluation[x][0]
			);
	}

	fclose(result);
#endif

//Double]
#ifdef DOUBLE
	for(int x = 0 ; x < 26 ; x++){
		for(int y = 0 ; y < 3 ; y++){
			item_evaluation[x][y] = 0;
		}
	}
	for(int item_num = 1 ; item_num <= 25 ; item_num++){
		for(int pattern = 0 ; pattern < 75 ; pattern++){
			for(int scene = 1 ; scene <= 5 ; scene++){
				for(int item = 0 ; item < 2 ; item++){
					if(item_num == double_name[pattern][item]){
						sprintf_s(label_dir, "%s/double/%d_%d/%d", label_pass, double_name[pattern][0], double_name[pattern][1], scene);
						sprintf_s(test_dir,  "%s/double/%d_%d/%d/%d", test_pass, double_name[pattern][0], double_name[pattern][1], scene, double_name[pattern][item]);

						evaluation(label_dir, test_dir, double_name[pattern][item], item_color[double_name[pattern][item]][0], item_color[double_name[pattern][item]][1], item_color[double_name[pattern][item]][2]);

						item_evaluation[double_name[pattern][item]][0]++;

						for(int num = 0 ; num < 3 ; num++){
							item_evaluation[double_name[pattern][item]][num+1] = item_evaluation[double_name[pattern][item]][num+1] + result_bool[num];
						}
					}
				}//item
			}//scene
		}//pattern
		printf("double item_num : %d\n", item_num);
	}//item_num
	printf("\n");

	sprintf_s(result_pass, "%s/double_F%.3f_result.txt", result_pass, F_th);
	error = fopen_s(&result, result_pass, "w");
	fprintf(result, "          point     segmentation\n");

	for(int x = 1 ; x < 26 ; x++){
		fprintf(result, "item_%02d : %02d/%02d        %02d/%02d\n", 
			x, 
			item_evaluation[x][1], item_evaluation[x][0], 
			item_evaluation[x][2], item_evaluation[x][0]
			);
	}

	fclose(result);
#endif

//Multi]
#ifdef MULTI
	for(int x = 0 ; x < 26 ; x++){
		for(int y = 0 ; y < 3 ; y++){
			item_evaluation[x][y] = 0;
		}
	}
	for(int item_num = 1 ; item_num <= 25 ; item_num++){
		for(int pattern = 0 ; pattern < 34 ; pattern++){
			for(int scene = 1 ; scene <= 5 ; scene++){
				for(int item = 0 ; item < 3 ; item++){
					if(item_num == multi3_name[pattern][item]){
						sprintf_s(label_dir, "%s/multi/%d_%d_%d/%d", label_pass, multi3_name[pattern][0], multi3_name[pattern][1], multi3_name[pattern][2], scene);
						sprintf_s(test_dir,  "%s/multi/%d_%d_%d/%d/%d", test_pass, multi3_name[pattern][0], multi3_name[pattern][1], multi3_name[pattern][2], scene, multi3_name[pattern][item]);

						evaluation(label_dir, test_dir, multi3_name[pattern][item], item_color[multi3_name[pattern][item]][0], item_color[multi3_name[pattern][item]][1], item_color[multi3_name[pattern][item]][2]);

						item_evaluation[multi3_name[pattern][item]][0]++;

						for(int num = 0 ; num < 3 ; num++){
							item_evaluation[multi3_name[pattern][item]][num+1] = item_evaluation[multi3_name[pattern][item]][num+1] + result_bool[num];
						}
					}
				}//item
			}//scene
		}//pattern

		for(int pattern = 0 ; pattern < 6 ; pattern++){
			for(int scene = 1 ; scene <= 5 ; scene++){
				for(int item = 0 ; item < 4 ; item++){
					if(item_num == multi4_name[pattern][item]){
						sprintf_s(label_dir, "%s/multi/%d_%d_%d_%d/%d", label_pass, multi4_name[pattern][0], multi4_name[pattern][1], multi4_name[pattern][2], multi4_name[pattern][3], scene);
						sprintf_s(test_dir,  "%s/multi/%d_%d_%d_%d/%d/%d", test_pass, multi4_name[pattern][0], multi4_name[pattern][1], multi4_name[pattern][2], multi4_name[pattern][3], scene, multi4_name[pattern][item]);

						evaluation(label_dir, test_dir, multi4_name[pattern][item], item_color[multi4_name[pattern][item]][0], item_color[multi4_name[pattern][item]][1], item_color[multi4_name[pattern][item]][2]);

						item_evaluation[multi4_name[pattern][item]][0]++;

						for(int num = 0 ; num < 3 ; num++){
							item_evaluation[multi4_name[pattern][item]][num+1] = item_evaluation[multi4_name[pattern][item]][num+1] + result_bool[num];
						}
					}
				}//item
			}//scene
		}//pattern
		printf("multi item_num : %d\n", item_num);
	}//item_num
	printf("\n");

	sprintf_s(result_pass, "%s/multi_F%.3f_result.txt", result_pass, F_th);
	error = fopen_s(&result, result_pass, "w");
	fprintf(result, "          point     segmentation\n");

	for(int x = 1 ; x < 26 ; x++){
		fprintf(result, "item_%02d : %02d/%02d        %02d/%02d\n", 
			x, 
			item_evaluation[x][1], item_evaluation[x][0], 
			item_evaluation[x][2], item_evaluation[x][0]
			);
	}

	fclose(result);
#endif

}

int point_evaluation(cv::Mat label_img, cv::Mat test_img, int item_num){

	int point[2] = {-1, -1};
	int point_bool;

	for(int i = 0 ; i < test_img.rows ; i++){
		for(int j = 0 ; j < test_img.cols ; j++){
			if(test_img.data[(j*3) + i * test_img.step] == 0 && test_img.data[(j*3+1) + i * test_img.step] == 0 && test_img.data[(j*3+2) + i * test_img.step] == 255){
				point[0] = j;
				point[1] = i;
			}
		}
	}

	if(point[0] > 0 && point[1] > 0){
		if(label_img.data[(point[0]*3) + point[1] * label_img.step]  == item_color[item_num][2] 
		 && label_img.data[(point[0]*3+1) + point[1] * label_img.step]  == item_color[item_num][1] 
		  && label_img.data[(point[0]*3+2) + point[1] * label_img.step]  == item_color[item_num][0]){
			point_bool = 1;
		}
		else{
			point_bool = 0;
		}
	}
	else{
		point_bool = 0;
	}
	return (point_bool);
}

double seg_evaluation(cv::Mat label_img, cv::Mat seg_img, int item_R, int item_G, int item_B){

	int count[2][2];
	double recall, precision, f_measure;

	cv::Mat test_img(cv::Size(seg_img.cols, seg_img.rows), CV_8UC3, cv::Scalar(0));

	for(int i = 0 ; i < test_img.rows ; i++){
		for(int j = 0 ; j < test_img.cols ; j++){
			if(seg_img.data[(j*3) + i * seg_img.step] == 0
			 && seg_img.data[(j*3+1) + i * seg_img.step] == 0
			  && seg_img.data[(j*3+2) + i * seg_img.step] == 0){
				test_img.data[(j*3) + i * test_img.step] = 0;
				test_img.data[(j*3+1) + i * test_img.step] = 0;
				test_img.data[(j*3+2) + i * test_img.step] = 0;
			}
			else{
				test_img.data[(j*3) + i * test_img.step] = 255;
				test_img.data[(j*3+1) + i * test_img.step] = 255;
				test_img.data[(j*3+2) + i * test_img.step] = 255;
			}
		}
	}

	for(int e = 0 ; e < 2 ; e++){
		for(int s = 0 ; s < 2 ; s++){
			count[e][s] = 0;
		}
	}

	for(int i = 0 ; i < seg_img.rows ; i++){
		for(int j = 0 ; j < seg_img.cols ; j++){
			if(label_img.data[(j*3) + i * label_img.step] == item_B
				&& label_img.data[(j*3+1) + i * label_img.step] == item_G
				&& label_img.data[(j*3+2) + i * label_img.step] == item_R){
							
				if(test_img.data[(j*3) + i * test_img.step] == 255
					&& test_img.data[(j*3+1) + i * test_img.step] == 255
					&& test_img.data[(j*3+2) + i * test_img.step] == 255){
					count[0][0]++;
				}
				else{
					count[0][1]++;
				}
							
			}
			else{
						
				if(test_img.data[(j*3) + i * test_img.step] == 255
					&& test_img.data[(j*3+1) + i * test_img.step] == 255
					&& test_img.data[(j*3+2) + i * test_img.step] == 255){
					count[1][0]++;
				}
				else{
					count[1][1]++;
				}
			}
		}
	}

	if(count[0][0] + count[0][1] != 0){
		recall = (double)count[0][0] / (count[0][0] + count[0][1]);
	}
	else{
		recall = 0.0;
	}

	if(count[0][0] + count[1][0] != 0){
		precision = (double)count[0][0] / (count[0][0] + count[1][0]);
	}
	else{
		precision = 0.0;
	}

	if(recall * precision != 0){
		f_measure = (2 * recall * precision) / (recall + precision);
	}
	else{
		f_measure = 0.0;
	}
	return (f_measure);
}


void evaluation(char Label_dir[1024], char Test_dir[1024], int item_num, int item_R, int item_G, int item_B){

	char label_dir[1024];
	char result_dir[1024];

	cv::Mat label_img;
	cv::Mat result_img;

	char f_filename[1024];
	double F_measure;

	sprintf_s(label_dir, "%s/label.bmp", Label_dir);
	sprintf_s(result_dir, "%s/result.bmp", Test_dir);

	//摜ǂݍ
	label_img = cv::imread(label_dir, 1);
	if(label_img.empty()){
		printf("error:label_img\n");
		printf("%s\n\n", Label_dir);
	}

	result_img = cv::imread(result_dir, 1);
	if(result_img.empty()){
		printf("error:result_img\n");
		printf("%s\n\n", Test_dir);
	}


	////W]
	if(result_img.empty() == 0){
		result_bool[0] = point_evaluation(label_img, result_img, item_num);
	}
	else{
		result_bool[0] = 0;
	}


	//FlZo
	if(result_img.empty() == 0){
		F_measure = seg_evaluation(label_img, result_img, item_R, item_G, item_B);
	}
	else{
		F_measure = 0.0;
	}

	std::ofstream f_result(f_filename);

	f_result << F_measure << std::endl;
	if(F_measure >= F_th){
		result_bool[1] = 1;
	}
	else{
		result_bool[1] = 0;
	}

	f_result.close();

}